const electron = require('electron')
const { app, BrowserWindow ,dialog,Notification,globalShortcut} = electron
const path = require('path')
const url = require('url')

const ipc = electron.ipcMain

const $notify = require('./notify')
const $screenShot = require('./shootScreen')
const $tray = require('./tray')
const $downFile = require('./downFile')
//const $updateCh = require('./update')
const $updateLinux = require('./updateLinux')
const $ipconfig = require('./ipconfig')
const $paste = require('./paste')
const fs = require('fs')
const baseUrl = $ipconfig.baseUrl;
const baseFileUrl = $ipconfig.baseFileUrl;

let mainWindow
let loginWindow
global.isclose=false
const Datastore = require('nedb')
global.data_db=new Datastore({
     filename:baseFileUrl+'/db/data.db',
     autoload:true
})
const localURL="http://192.168.20.19:9911";
const oaURL="http://192.168.20.19:9911";
const localFILE=$ipconfig.fileUrl;
//2018/9/4修改
app.setAppUserModelId('gingo')
//2018/9/21 获取当前版本
var package = require("./package.json");
//2018/10/29 监听一次
var isFirst=0;
//2019/2/19 isclose
var isclose=1;
global.version = package.version;
function createWindow (loginUserid) {
  global.loginUserid = loginUserid;
  // Create the browser window.
  global.mainWindow = new BrowserWindow({      
      width: 991, 
      height: 630,
      resizable: true,//能否改变窗体大小
      title: '即时通讯',
      show: false,
      skipTaskbar:false,
      webPreferences: { zoomFactor: 1.0 } ,
      //webPreferences: {nodeIntegration: false},   //阻止node引擎
      frame: true  //无边框
  })
  isclose=0;
  global.mainWindow.setMenu(null)
  //取消视觉闪烁
  //global.mainWindow.loadURL('http://127.0.0.1:9911/index.html')
  global.mainWindow.loadURL(global.localURL+'/index.html')
  //global.mainWindow.loadURL('http://192.168.0.165:8866/')
//mainWindow.maximize(); 
    // and load the index.html of the app.
  // mainWindow.loadURL(url.format({
  //   pathname: path.join(__dirname, './index.html'),
  //   protocol: 'file:',
  //   slashes: true
  // }))
  global.mainWindow.once('ready-to-show', () => {
    global.mainWindow.show()
    // 更新程序
    //$updateCh.updateHandle(global.mainWindow)
    $updateLinux.updateHandle()
    //2020-4-29 新增
    global.mainWindow.setIcon(path.resolve(__dirname, './static/icon.png'))
  })
  // Open the DevTools.
  //global.mainWindow.webContents.openDevTools()
  // Emitted when the window is closed.
  global.mainWindow.on('close', function (e) {
    // Dereference the window object, usually you would store windows
    // in an array if your app supports multi windows, this is the time
    // when you should delete the corresponding element.
    if(!global.isclose){
      e.preventDefault()
      global.mainWindow.hide();
    }
  })
  global.mainWindow.on('closed',function (e){
     isclose=1;
  })
  // 本地唤起
  if(!app.isDefaultProtocolClient('jwchatArouse'))
      app.setAsDefaultProtocolClient('jwchatArouse')
  // 托盘
  $tray.trayListen();
  if(isFirst==0){
    // 注册截图
    $screenShot();
    // 注册推送
    $notify()
    // 文件
    $downFile.downListen()
    // 文件压缩
    $paste.pasteListen()
    //window event
    ipc.on('START:BintangEvent', (event, arg) => {
        if(global.loginUserid){
          global.mainWindow.webContents.send('Bintang',{ userId: global.loginUserid } )
          return;
        }
        process.argv.forEach(function(val, index, array) {
          if(val.indexOf('userId')>-1){
               global.mainWindow.webContents.send('Bintang',{ userId: val.split('userId=')[1].replace(/\//g,'') } )
          }
        });
    })
    globalShortcut.register('f5', function() {
        if(global.mainWindow&&global.mainWindow.isFocused()){
             global.mainWindow.reload()
        }
    });
    isFirst=1;
  }
}
function createLogin(){
  loginWindow = new BrowserWindow({
     width: 320, 
     height: 480,
     frame: false,
     show: false,
  })
  loginWindow.loadURL(url.format({
    pathname: path.join(__dirname, './login/login.html'),
    protocol: 'file:',
    slashes: true
  }))
  //loginWindow.webContents.openDevTools()
  loginWindow.once('ready-to-show', () => {
    loginWindow.show();
    //2020-4-29 新增
    loginWindow.setIcon(path.resolve(__dirname, './static/icon.png'))
  })
  loginWindow.on('close', function (e) {
    if(!global.isclose){
      e.preventDefault()
      loginWindow.hide();
    }
  })
  // 托盘
  //$tray.trayLoginListen(loginWindow);
  // 本地唤起
  if(!app.isDefaultProtocolClient('jwchatArouse'))
      app.setAsDefaultProtocolClient('jwchatArouse')
}
//const shouldQuit = app.makeSingleInstance((commandLine, workingDirectory) => {
  // Someone tried to run a second instance, we should focus our window.
//  if (isclose==0) {
//    if (global.mainWindow.isMinimized()) global.mainWindow.restore()
 //   global.mainWindow.show()
//    return;
//  }
 // if (loginWindow){
//    if (loginWindow.isMinimized()) loginWindow.restore()
//    loginWindow.show()
//  }
//})
//if(shouldQuit){
//  app.quit();
//}
 const gotTheLock = app.requestSingleInstanceLock()

 if (!gotTheLock) {
   app.quit()
 } else {
   app.on('second-instance', (event, commandLine, workingDirectory) => {
     // 当运行第二个实例时,将会聚焦到myWindow这个窗口
       if (isclose==0) {
         if (global.mainWindow.isMinimized()) global.mainWindow.restore()
        global.mainWindow.show()
         return;
       }
      if (loginWindow){
         if (loginWindow.isMinimized()) loginWindow.restore()
         loginWindow.show()
       }
   })
 }

// This method will be called when Electron has finished
// initialization and is ready to create browser windows.
// Some APIs can only be used after this event occurs.
app.on('ready', () => {
  var configlogin=false;
  process.argv.forEach(function(val, index, array) {
  console.log(val)
      if(val.indexOf('userId')>-1){
          configlogin=true;
      }
  });
  ipc.on('socket:disconnect',(e)=>{
      setTimeout(()=>{
         global.mainWindow.destroy()
         if(loginWindow){
            loginWindow.show()
            $tray.trayLoginListen(loginWindow);
         }else{
            createLogin()
         }
      },500)
  })
  ipc.on('Login:minwin', e=> loginWindow.minimize());
  //ipc.on('Login:close', e=> loginWindow.hide());
  ipc.on('Login:close', e=> {
     global.isclose=true;
     app.quit();
  });
  ipc.on('Login:success',(e,args)=>{
       if(loginWindow) loginWindow.hide()
       createWindow(args.userId);
       // if(mainWindow){
       //     $tray.trayListen(mainWindow);
       //     mainWindow.webContents.send('Bintang',{ userId: args.userId })
       //     mainWindow.show();
       // }else{
       //     createWindow(args.userId)
       // }
  })
  global.data_db.find({id:1},function(err,docs){
      if(docs.length==0){
          let doc={
             id:1,
             localURL:localURL,
             oaURL:oaURL,
             localFILE:localFILE
          }
          global.data_db.insert(doc,function(err,new_doc){
            console.log(err,new_doc)
          })
          global.localURL=localURL;
          global.oaURL=oaURL;
          global.localFILE=localFILE;
      }else{
        global.localURL=docs[0].localURL;
        global.oaURL=docs[0].oaURL;
        docs[0].localFILE ? global.localFILE=docs[0].localFILE : global.localFILE=localFILE;
      }
      configlogin ? createWindow():createLogin()
  })
})
app.on('browser-window-focus', function (e) {
  $tray.clearTray();
})
// Quit when all windows are closed.
app.on('window-all-closed', function (e) {
  e.preventDefault()
  if (process.platform !== 'darwin') {
    //app.quit()
  }
})

app.on('activate', function () {
  if (global.mainWindow === null) {
    createWindow()
  }
})

// In this file you can include the rest of your app's specific main process
// code. You can also put them in separate files and require them here.












