const electron =  require('electron')
const { ipcMain,BrowserWindow,globalShortcut } = electron;
let win = null;
let url = require('url');
let path = require('path');
global.sharedObject = {
  imgData: ''
}
/**
 * 创建截屏窗口
 */
function createChildWin(_url, opts) {
    var config = {
        fullscreen: true,
        frame: false,
        show: false
    }
    config = Object.assign(config, opts)
    var _win = new BrowserWindow(config);
    _win.loadURL(url.format({
        pathname: path.join(__dirname + _url),
        protocol: 'file',
        slashes: true
    }))
    _win.once('ready-to-show', () => {
        _win.show()
    })
    _win.on('closed', () => {
        _win = null;
    })
    _win.on('close', () => {
        _win = null;
    })
    return _win;
}
/**
 * 关闭窗口 取消截屏
 * @param  _win 
 */
function clearWindow(_win) {
    _win && _win.close()
}

module.exports = function(obj) {
    // 接收截图工具信号
    ipcMain.on('SHOOT:screenshot-page', function(event, arg) {
        switch (arg.type) {
            case 'close':
                global.mainWindow.webContents.send('CHILD:quit-cut')
                win && clearWindow(win);
                win = null;
                break;
            case 'done':
                global.mainWindow.webContents.send('CHILD:done',arg)
                break;
            default:
                break;
        }
    });
    ipcMain.on('SHOOT:createChildWin', (event, arg) => {
        if(!win){
          win = createChildWin('/index.html', { fullscreen: true, width: 900, height: 800, 
            alwaysOnTop: true, skipTaskbar: false, autoHideMenuBar: true, });
          //win.webContents.openDevTools()
        }
    })
    // 退出快捷键
    //var quitShot = (obj&& obj.quit) || 'esc';
    var shotKey = (obj&& obj.shotKey) || 'ctrl+space';
    //注册快捷键
    // globalShortcut.register(quitShot, function() {
    //     winContent.send('CHILD:quit-cut', 1);
    //     win && clearWindow(win);
    //     win = null;
    // });
    // 截图快捷键
    // globalShortcut.register('ctrl+space', function() {
    //     winContent.send('CHILD:global-shortcut-capture', 1);
    // });
};
