const electron = require('electron')
const path = require('path')
const {app,Menu,Tray} = electron
//系统托盘图标闪烁
let count = 0,timer = null   
//右下角的图标
let tray = null
//定时器开启状态
let isInter=false;
//创建闪烁
addTray = () => {
    if(!isInter){
      isInter=true;
      count=0;
      timer=setInterval(function() {
          count++;
          if (count%2 == 0) {
              tray.setImage(path.resolve(__dirname, '../static/icon.png'))
          } else {
              tray.setImage(path.resolve(__dirname, '../static/ic.png'))
          }
      }, 600);
    }
}
//清除闪烁
clearTray = () => {
    if(isInter){
        global.clearInterval(timer); 
        tray.setImage(path.resolve(__dirname, '../static/icon.png'))
        isInter=false;
    }
}
trayListen = function() {
    if(tray)  tray.destroy()
    tray = new Tray(path.resolve(__dirname, '../static/icon.png'))
    //右键菜单项 可以是多个 这里只有关闭一个项
    const contextMenu = Menu.buildFromTemplate([
      {label: '关闭', click: function(){
          global.isclose=true;
          app.quit();
      }},
      {label: '显示窗口', click: function(){
          clearTray()
          if (!global.mainWindow.isVisible()) global.mainWindow.show()
          if (global.mainWindow.isMinimized()) global.mainWindow.restore()
      }}
    ]);
    tray.setContextMenu(contextMenu);
    //设置此托盘图标的悬停提示内容
    tray.setToolTip('金鸽.');
    tray.on('double-click',() => {
      clearTray()
      if (!global.mainWindow.isVisible()) global.mainWindow.show()
      if (global.mainWindow.isMinimized()) global.mainWindow.restore()
      //mainWindow.focus()
    })
    tray.on("click",() => {
      clearTray()
      if (!global.mainWindow.isVisible()) global.mainWindow.show()
      if (global.mainWindow.isMinimized()) global.mainWindow.restore()
      //mainWindow.focus()
    })
}
trayLoginListen = function(loginWindow) {
    if(tray)  tray.destroy()
    tray = new Tray(path.resolve(__dirname, '../static/icon.png'))
    //右键菜单项 可以是多个 这里只有关闭一个项
    const contextMenu = Menu.buildFromTemplate([
      {label: '关闭', click: function(){
          global.isclose=true;
          app.quit();
      }},
      {label: '显示窗口', click: function(){
          clearTray()
          if (!loginWindow.isVisible()) loginWindow.show()
          if (loginWindow.isMinimized()) loginWindow.restore()
      }}
    ]);
    tray.setContextMenu(contextMenu);
    //设置此托盘图标的悬停提示内容
    tray.setToolTip('金鸽.');
    tray.on('double-click',() => {
      clearTray()
      if (!loginWindow.isVisible()) loginWindow.show()
      if (loginWindow.isMinimized()) loginWindow.restore()
      //mainWindow.focus()
    })
    tray.on("click",() => {
      clearTray()
      if (!loginWindow.isVisible()) loginWindow.show()
      if (loginWindow.isMinimized()) loginWindow.restore()
      //mainWindow.focus()
    })
}
module.exports = {   
    "clearTray": clearTray,
    "addTray": addTray, 
    "trayListen": trayListen,
    "trayLoginListen": trayLoginListen   
};









